from tinyTierraAssembler import *
import random
taskTable= []       # タスク(スライス)テーブル
geneNo   = 0        # 生成番号(スライス識別用番号)
execQue  = []       # 実行待ち行列
NGET     = 80       # 領域確保単位
NSOUP    = NGET*100 # スープ領域のサイズ
pSoup    = 0        #使用スープ領域ポインタ　　
Soup=[0xFF for i in range(NSOUP)]#スープ領域
NRange   =150       #テンプレート識別範囲
Reaper   = False    #リーパ(死神)活動フラグ
ReapQue  = []       #リーパ待ち行列
Bank     = []       #パターン保存領域
CopyError= 0        #自己複製エラー確率
OpeError = 0        #演算処理エラー確率
def setCopyOpeError(Copy,Ope):
    global CopyError,OpeError
    CopyError=Copy; OpeError=OpeError
def checkSoup(IPAT,IP):#■パターンのチェック(4パターンまで)
    global pSoup,Soup,NRange
    for i in range(4):
        if IP+i>(pSoup+NGET): return False
        if IPAT[i]!=0 and IPAT[i]!=1: return True
        if IPAT[i]!=Soup[IP+i]:return False
    return True
def setPattern(CI):#■相補的パターンの設定
    global pSoup,Soup,NRange
    IPAT=[0 for i in range(4)];IP=CI+1
    for i in range(4):
        if IP+i<NSOUP:IPAT[i]=Soup[IP+i] ^ 1
        else:IPAT[i]=0x05
    return IPAT
def afterAddress(EV,CI):#■後方パターン
    global pSoup #,Soup,NRange
    IPAT=setPattern(CI);IP=CI+3
    for i in range(NRange):
        IP+=1
        if IP>=pSoup+NGET: return -1
        if checkSoup(IPAT,IP): return IP+4
    return -1
def beforAddress(EV,CI):#■前方パターン
    global pSoup,Soup,NRange
    IPAT=setPattern(CI); IP=CI-3
    for i in range(NRange):
        IP-=1
        if IP<0: return -1
        if checkSoup(IPAT,IP):return IP+4
    return -1
def bothSideAddress(EV,CI):#■両サイド・パターン
    global NRange
    IPAT=setPattern(CI); IP1=CI+3; IP2=CI-3
    for i in range(NRange):
        IP1+=1; IP2-=1
        if IP1>=pSoup and IP2<0: return -1
        if IP1<pSoup:
            if checkSoup(IPAT,IP1):return IP1+4
        if IP2>=0:
            if checkSoup(IPAT,IP2): return IP2+4
    return -1
def stackErr(SS,SS2,EV):
    print(SS+" Local Stack ",SS2," アドレス%d"%EV[7])
def push_dt(EV,DT,SS):#■スタックPush
    ID=EV[5]
    if ID>19:stackErr(SS,"Overflow",EV);EV[4]=1
    else: EV[4]=0;EV[6][ID]=DT;EV[5]=ID+1
    return EV
def pop_dt(EV,IR,SS):#■スタックPop
    ID=EV[5]
    if ID<=0:stackErr(SS,"Empty",EV);EV[4]=1
    else: ID-=1;EV[IR]=EV[6][ID];EV[5]=ID;EV[4]=0
    return EV
def notOpErr():#■命令実行エラーを起こすかどうかの判定
    global opeError
    if OpeError==0: return True
    elif random.random()>OpeError:return True
    return False
#-------------インタプリタ関数-------------------
def nop_0(EV,CI):         return EV   #0x00
def nop_1(EV,CI):         return EV   #0x01
def or1(EV,CI):                       #0x02
    if notOpErr(): EV[2] ^=1
    return EV
def sh1(EV,CI):                       #0x03
    if notOpErr(): EV[2] <<=1
    return EV
def zero(EV,CI):EV[2] =0; return EV   #0x04
def if_cz(EV,CI):                     #0x05
    if EV[2]!=0: EV[7]+=1
    return EV
def sub_ab(EV,CI):                    #0x06
    if notOpErr():EV[2] = EV[0]-EV[1]
    return EV
def sub_ac(EV,CI):                    #0x07
    if notOpErr():EV[0] =EV[0]-EV[2]
    return EV
def inc_a(EV,CI):                     #0x08
    if notOpErr():EV[0]+=1
    return EV
def inc_b(EV,CI):                     #0x09
    if notOpErr():EV[1]+=1
    return EV
def dec_c(EV,CI):                     #0x0A
    if notOpErr():EV[2]-=1
    return EV
def inc_c(EV,CI):                     #0x0B
    if notOpErr(): EV[2]+=1
    return EV
def push_ax(EV,CI): return push_dt(EV,EV[0],"ax") #0C
def push_bx(EV,CI): return push_dt(EV,EV[1],"bx") #0D
def push_cx(EV,CI): return push_dt(EV,EV[2],"cx") #0E
def push_dx(EV,CI): return push_dt(EV,EV[3],"dx") #0F

def pop_ax(EV,CI): return pop_dt(EV,0,"ax") #10
def pop_bx(EV,CI): return pop_dt(EV,1,"bx") #11
def pop_cx(EV,CI): return pop_dt(EV,2,"cx") #12
def pop_dx(EV,CI): return pop_dt(EV,3,"dx") #13
def jmp(EV,CI):#0x15
    global pSoup,Soup,NRange
    Address=bothSideAddress(EV,CI)
    if Address<0:EV[4]=1
    else: EV[4]=0;EV[7]=Address
    return EV
def jmpb(EV,CI):#0x15
    global pSoup,Soup,NRange
    Address=beforAddress(EV,CI)
    if Address<0:EV[4]=1
    else: EV[4]=0;EV[7]=Address
    return EV
def call(EV,CI):#0x16
    global pSoup,Soup,NRange
    Address=bothSideAddress(EV,CI)
    if Address<0: EV[4]=1
    else:
        EV[4]=0; push_dt(EV,EV[7],"Program")
        EV[7]=Address
    return EV
def ret(EV,CI):return pop_dt(EV,7,"return")#0x17
def mov_cd(EV,CI):EV[3]=EV[2];return EV    #0x18
def mov_ab(EV,CI):EV[1]=EV[0];return EV    #0x19
def mov_iab(EV,CI):                        #0x1A
    global Soup,CopyError;ID1=EV[1];ID0=EV[0]
    if (ID0>=0 and ID0<pSoup+NGET and
        ID1>=0 and ID1<pSoup+NGET):
        Soup[ID0]=Soup[ID1]
        if CopyError!=0:#自己複製エラー処理
            Rand=random.random()
            if Rand<CopyError:
                IR=int(Rand/CopyError*5+0.5);V=2**IR
                Soup[ID0]^=V
    else:EV[4]=1
    return EV
def adr(EV,CI):    #0x1B
    ID=EV[0];Address=bothSideAddress(EV,ID)
    if Address<0: EV[4]=1
    else: EV[4]=0; EV[0]=Address
    return EV
def adrb(EV,CI):    #0x1C
    Address= beforAddress(EV,CI)
    if Address<0: EV[4]=1
    else: EV[4]=0; EV[0]=Address
    return EV
def adrf(EV,CI):    #0x1D
    Address= afterAddress(EV,CI)
    if Address<0: EV[4]=1
    else: EV[4]=0; EV[0]=Address
    return EV
def mal(EV,CI):    #0x1E
    global pSoup, Soup,Reaper
    if pSoup>=NSOUP*0.8: Reaper=True
    if pSoup+NGET<NSOUP:
        Soup[pSoup]=0 #領域確保排他制御用
        EV[0]=pSoup;EV[4]=0; pSoup+=NGET
        return EV
    else:
        for i in range(0,NSOUP,NGET):
            if Soup[i]==0xFF:
                Soup[i]=0 #領域確保排他制御用
                EV[0]=i; EV[4]=0; return EV
        EV[4]=1;EV[0]=-1#確保失敗
        return EV
def divide(EV,CI): #0x1F
    global NRange,pSoup,Soup
    EV[7]=EV[8][2]#プログラム・カウンタを先頭に戻す
    if EV[2]>NGET:EV[2]=NGET #領域保護用(NGET単位のため)
    regTask(EV[0],EV[8][1],EV[0]+EV[2])
    return EV
#----------インタプリタ制御---------------------
#EV=[ax, bx, cx, dx,fl, sp,st[20],ip,
#    [サイズ, 生成番号,先頭アドレス,親スライス]]

execTab= (nop_0  ,nop_1  ,or1    ,sh1    , #0x00
          zero   ,if_cz  ,sub_ab ,sub_ac , #0x04
          inc_a  ,inc_b  ,dec_c  ,inc_c  , #0x08
          push_ax,push_bx,push_cx,push_dx, #0x0C
          pop_ax ,pop_bx ,pop_cx ,pop_dx , #0x10
          jmp    ,jmpb   ,call   ,ret    , #0x14
          mov_cd ,mov_ab ,mov_iab,adr    , #0x18
          adrb   ,adrf   ,mal    ,divide ) #0x1A
def moveReaper(EV,after=True):#■リーパ行列移動
    global ReapQue,Soup;
    GNO=EV[8][1];N=len(ReapQue)
    for i in range(N):
        if GNO==ReapQue[i]:
            if after:#後と入れ替えるとき
                if i>=N-1: return
                ib=i+1
            else:    #前と入れ替えるとき
                if i==0: return
                ib=i-1
            T=ReapQue[ib]; ReapQue[ib]=ReapQue[i]
            ReapQue[i]=T
            return
def execP(DebugMode):#■インタプリタ
    global Soup,execQue,taskTable
    if DebugMode==2:
        print("\n  No. Address   Code     ax   bx"+
              "   cx   dx   pc   sp  stk ")
        print("-"*70)
    LMAX=len(execQue)*1000;L=0
    while execQue!=[]:# 待ち行列がなくなるまで実行
        L+=1#永久ループ対策
        if L>LMAX:
            print("スライス", execQue[0],
                  "永久ループの恐れあり。停止します")
            taskTable[BQID][4]=((SI+1)*100+99)
            del execQue[0]
            break
        if L%5000==0: print("実行ループ回数%d MAX %d"%(L,LMAX))
        BQID=execQue[0]; EV=taskTable[BQID];SI=EV[7];
        if SI>=0 and SI<NSOUP :# カウンタ正または0のとき
            #print("カウンタ",BQID,SI)ループ回数
            taskTable[BQID][4]=0;CD=Soup[SI];EV[4]=0
            if CD>=len(execTab) or CD<0:
                taskTable[BQID][4]=((SI+1)*100)
                taskTable[BQID][7]=-1
            else:
                EV[7]=SI+1;EV=execTab[CD](EV,SI)# 1命令実行
                #print("execQue L=%d SI=%d LMAX=%d"%(L,SI,LMAX))
                if DebugMode==2:prRegister(BQID, SI,CD,EV)
                if EV[4]==1:#エラーのとき待ち行列削除
                    taskTable[BQID][4]=((SI+1)*100+CD)
                    taskTable[BQID][7]=-1
                    if execQue==[]:break
                    del execQue[0] #=delExecQue(execQue)
                if CD==0x1F:#プログラム終了(tiny Tierraのみ)
                    if execQue==[]:break
                    del execQue[0]
                else:
                    taskTable[BQID][4]=0
                    if execQue==[]:break
                    X=execQue[0];
                    del execQue[0]#=ExecQue(execQue)
                    execQue.append(X)
                    #print("execQue append ",execQue)
                        
        else: del execQue[0]# カウンタ負のとき待ち行列削除
        #print("execQue",execQue)
    for i in range(len(taskTable)):
        if taskTable[i][4]!=0:#エラー時処理
            if DebugMode==1:
                ERCode=taskTable[i][4];EROP=ERCode%100
                ERAD=int(ERCode/100)-1
                if EROP==0:#命令コード例外
                    print((("スライス %d で命令コード例外."+
                            " アドレス %d") %(i, ERAD)))
                else:
                    print((("スライス %d で実行エラー."+
                            " アドレス %d コード=%02X") %
                           (i, ERAD,EROP)))
                taskTable[i][7]=taskTable[i][8][2]
                taskTable[i][4]==0
            moveReaper(taskTable[i],False)
        else: moveReaper(taskTable[i],True)#正常処理
def savePat(address,Nlen):#■生成パターン保存
    global Bank,Soup;DT=[];N=Nlen
    if N>NGET:N=NGET#領域サイズを超えたとき
    for i in range(N):
        if address+i<(NSOUP-1): DT.append(Soup[address+i])
        else: N=i;break
    for i in range(len(Bank)):
        if Bank[i][0]==N:
            chk=chkBank(N,address,Bank[i])
            if chk<0: Bank[i].append(DT)
            return
    Bank.append([N,DT])
def chkBank(N,address,Banki):
    for j in range(1,len(Banki)):
        kflag=True
        for k in range(N):
            if Banki[j][k]!=Soup[address+k]:
                kflag=False;break
        if kflag: return j-1
    return -1
def getPatNo(address,N):#■生成パターン番号を得る
    global Bank,Soup;
    for i in range(len(Bank)):
        if Bank[i][0]==N:
            chk=chkBank(N,address,Bank[i])
            return chk
    return -1
def regTask(address,mother,nextAddress):#■スライス生成
    global taskTable,geneNo; NLEN=nextAddress-address
    if NLEN<=10:return
    if address>=(NSOUP-1):return
    if Soup[address]==0xFF:return
    atr=[0 for i in range(4)]; 
    atr[0]=NLEN;atr[1]=geneNo;
    atr[2]=address;atr[3]=mother; geneNo+=1
    stk=[0 for i in range(20)];tcb=[0 for i in range(9)]
    tcb[6]=stk;tcb[7]=address;tcb[8]=atr; taskTable.append(tcb)
    ReapQue.append(atr[1])#リーパ待ち行列に追加
    savePat(address,atr[0])#生成パターンの保存
def bootStrap(Code):#■初期起動
    global taskTable,geneNo,Soup,pSoup
    pSoup=len(Code);
    for i in range(pSoup):Soup[i]=Code[i]
    regTask(0,-1,pSoup)
def execLoop(Code,N, ranType=2,eps=0.001,seed=0,LoopReaper=3,DebugMode=0):#■実行
    global taskTable, execQue,ReapQue,Soup,pSoup;
    if seed>0:random.seed(seed)
    ReapQue=[];Bank=[]
    for k in range(N):
        execQue=[];
        for i in range(len(taskTable)):
            execQue.append(i);taskTable[i][5]=0
        execP(DebugMode)
        if   ranType==1: # 固定的変異(寄生種のみ)
            if k==0:           # 寄生種の親
                Soup[NGET+42]=1;savePat(NGET,80)
        elif ranType==2: # 固定的変異
            if k==0:           # 寄生種の親
                Soup[NGET+42]=1
                savePat(NGET,80)
            if k==1:     # 免疫種
                Soup[NGET+40]=0;Soup[NGET+42]=0;Soup[NGET+29]=1
                savePat(NGET,80)
                Soup[NGET*2+40]=0;Soup[NGET*2+29]=1
                savePat(NGET*2,80)
        elif ranType==3: # ランダムな変異
            Rand=random.random()
            if Rand<eps:
                RP=int(random.random()*(pSoup+NGET))
                if RP<(pSoup+NGET) and RP%NGET!=0 :
                    ist=int(RP/NGET+0.00000001)*NGET;N=0
                    for i in range(NGET):
                        ii=ist+i
                        if (Soup[ii]==1 and Soup[ii+1]==1 and
                            Soup[ii+2]==1 and Soup[ii+3]==0):
                            N=i+5; break
                    if (N>4 and N<=NGET and RP<(ist+N-5)):
                        if Soup[ist]==0 and Soup[ist+1]==0xFF:
                            Soup[ist]=0xFF#領域確保失敗対策
                        else:
                            IR=int(random.random()*5+0.5)
                            V=2**IR;Soup[RP]^=V;savePat(ist,N)
        for i in range(0, pSoup+1,NGET):#領域確保失敗対策
            if Soup[i]==0 and Soup[i+1]==0xFF:Soup[i]=0xFF
        if Reaper:
            for i in range(LoopReaper):killReaper()
def killReaper():#■リーパ実行
    global ReapQue, taskTable,Soup
    if len(ReapQue)>0:
        kill=ReapQue[0];del ReapQue[0]
        for i in range(len(taskTable)):
            if taskTable[i][8][1]==kill:
                AD= taskTable[i][8][2]
                for k in range(NGET):Soup[AD+k]=0xFF
                del taskTable[i]
                return
#--------以下，表示用-------------------
def prRegister(SNO,SI,CD,EV):#■レジスタ等表示
    SS=("%5d%5d%s(%02X)%5d%5d%5d%5d%5d%5d"%
        (SNO, SI,stringCode(CD),CD,
         EV[0],EV[1],EV[2],EV[3],EV[7],EV[5]))
    SP=EV[5] #スタック表示
    for i in range(SP): SS+="%5d" %EV[6][i]
    print(SS)
def prBankELM(BankELM,SS):#■パターンの1要素を表示
    S=SS
    for i in range(len(BankELM)):
        if i%10==0: print(S);S="%08d"%i
        S+=" %02X" % BankELM[i]
    print(S)
def prBank():#■バンク中のパターンを表示
    global Bank
    for i in range(len(Bank)):
        print("length=",Bank[i][0])
        for j in range(1,len(Bank[i])):
            S=str(Bank[i][0])+noToName(j-1,3)
            prBankELM(Bank[i][j],S)
def prReaper():#■死神待ち行列を表示
    global ReapQue,Reaper;
    print("\n■Reaper 状態", Reaper, ReapQue)
def dumpSoup():#■スープ表示
    global pSoup,Soup;SS=""
    print("\n          0  1  2  3  4  5  6  7  8  9")
    print("-"*38)
    for i in range(0,pSoup,1):
        if i%10==0:
            if i !=0: print(SS)
            SS="%08d"%int(i)
        SS+=" %02X" %Soup[i]
    print(SS)
def setNameTable(taskTable):#■スライス別番号設定
    N=len(taskTable);R=[[0,0] for i in range(N)];
    for i in range(N):
        NN=taskTable[i][8][0];AD=taskTable[i][8][2]
        R[i][0]=NN;R[i][1]=getPatNo(AD,NN)
        if R[i][1]<0:
            savePat(AD,NN);R[i][1]=getPatNo(AD,NN)    
    return R
strCode=("a","b","c","d","e","f","g","h","i","j",
         "k","l","m","n","o","p","q","r","s","t",
         "u","v","w","x","y","z")
def noToName(DT,N):#■番号を名前に変換
    MOD=len(strCode);S="";D=DT
    for i in range(N):
        DD=D%MOD; S=strCode[DD]+S; D=int(D/MOD)
    return S
def genName(taskTable):#■スライス別名前表生成
    R=setNameTable(taskTable)
    N=len(R);A=["" for i in range(N)]
    for i in range(len(R)):
        if R[i][1]<0:
            A[i]=str(R[i][0])+"***"
        else:A[i]=str(R[i][0])+noToName(R[i][1],3)
    B=[["",0,0,0,0] for i in range(N)]
    for i in range(len(R)):
        B[i][0]=A[i]; B[i][1]=R[i][0]
        B[i][2]=taskTable[i][8][2]
        B[i][3]=taskTable[i][8][3]
        B[i][4]=taskTable[i][8][1]
    return B
def prNameTable(B):#■スライス別名前表表示
    print("\n■ Name Table(***は，実行エラーによるデータなしの領域)")
    for i in range(len(B)): print("   ",B[i])

